/*
    Read preferences

    Changelog:
    
    6.5.2016: Added ERRORCOLOR
    29.4.2016: Added UIGAP
    27.4.2016: GRID setting for prefs
    27.4.2016: Aspect ratio (aspect/ASPECT) added, ILLEGAL for illegal colors
    26.4.2016: The first version
*/

final int PAL=0,
          NTSC=1,
          SQUARE=2;
          
final int ILLEGAL=1; //Impossible #RGB value (no alpha)

class Preferences
{
    int       zoom=2,
              aspect=PAL,
              errorcolor=ILLEGAL;
    
    final int BWIDTH=21,            // Border width
              UIWIDTH=134,
              UICOLOR=#445060,
              UITEXT=#e0e0e0,
              UIROW=25,             // Button or text row height
              UIGAP=8,              // A gap
              MESSAGEDURATION=60*3; // How many frames messages last
              
    boolean   grid=false;
    
    String    path="",              // Default paths for files
              filename="unnamed";
    
    Preferences()
    {
    }
    
    // Read the preferences file
    void readprefs(String namn)
    {
        String row[]=loadStrings(namn);
        
        if(row==null)
            return;
            
        for(int i=0;i<row.length;i++) // Parse each line
        {
            if(row[i].length()>1)
            {
                String s[]=split(row[i],"=");
                
                if(s[0].equals("ZOOM"))
                {
                    zoom=int(s[1]);
                    if(zoom<1)
                        zoom=2;
                }
                if(s[0].equals("GRID"))
                {
                    grid=int(s[1])==1;
                }
                if(s[0].equals("ASPECT") && s.length>1)
                {
                    if(s[1].equals("PAL")) aspect=PAL;
                    if(s[1].equals("NTSC")) aspect=NTSC;
                    if(s[1].equals("SQUARE")) aspect=SQUARE;
                }
                if(s[0].equals("PATH") && s.length>1)
                {
                    path=s[1];
                    message("Default path: "+path);
                }
                if(s[0].equals("ERRORCOLOR") && s.length>1)
                {
                    if(!s[1].equals(""))
                    {
                        errorcolor=unhex(s[1]);
                        if(errorcolor<0 || errorcolor>=256*256*256) // Garbage
                            errorcolor=ILLEGAL;
                        else
                            errorcolor|=0xff000000; // Alpha
                    }
                }
            }
        }
    }
}
